#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <stdint.h>
#include "wgif.h"

#define WIDTH 300
#define HEIGHT 300


int fwr(uint8_t *ptr, size_t bytes, void *wp) {
    return fwrite(ptr, 1, bytes, wp);
}

struct food {
    int x, y;
};

#define FC 10
struct food food[FC];

int dir=2; // Nord=0, Nord-Ost=1, Ost=2, Ost-Süd=3, Süd=4, Süd-West=5, West=6, West-Nord=7
int maul=1; // <:1, o:0
int cx, cy;

void drawpac(uint8_t *buf) {
    #define L 33
    int i, j, l, k;
    int c;

    for (i=0;i<L;i++) {
        for(j=0;j<L;j++) {
            l=16-i;
            k=16-j;
            if (sqrt(l*l+k*k)<15) {
                c=1;
            } else {
                c=0;
            }
            buf[j+L*i]=c;
        }
    }

    if (maul) {
        switch (dir) {
            case 6: { //W
                for (i=0;i<L;i++) {
                    for (j=0;j<L;j++) {
                        if (j<15 && (i<L-j && i>j)) {
                            buf[j+L*i]=0;
                        }
                    }
                }
                break;
            }
            case 2: { //O
                for (i=0;i<L;i++) {
                    for (j=0;j<L;j++) {
                        if (j>15 && (i>L-j && i<j)) {
                            buf[j+L*i]=0;
                        }
                    }
                }
               break;
            }
            case 4: { //S
                for (i=0;i<L;i++) {
                    for (j=0;j<L;j++) {
                        if ((i>L-j && j<=15) || (i>j && j>15)) {
                            buf[j+L*i]=0;
                        }
                    }
                }
               break;
            }
            case 0: { //N
                for (i=0;i<L;i++) {
                    for (j=0;j<L;j++) {
                        if ((i<j &&j<=15) || (j>15 && i<31-j)) {
                            buf[j+L*i]=0;
                        }
                    }
                }
                break;
            }
            case 1: { //NO
                for (i=0;i<L;i++) {
                    for (j=0;j<L;j++) {
                        if (j>15 && i<15) {
                            buf[j+L*i]=3;
                        }
                    }
                }
                break;
            }
            case 7: { //NW
                for (i=0;i<L;i++) {
                    for (j=0;j<L;j++) {
                        if (j<15 && i<15) {
                            buf[j+L*i]=0;
                        }
                    }
                }
                break;
            }
            case 3: { //SO
                for (i=0;i<L;i++) {
                    for (j=0;j<L;j++) {
                        if (j>15 && i>15) {
                            buf[j+L*i]=0;
                        }
                    }
                }
                break;
            }
            case 5: { //SW
                for (i=0;i<L;i++) {
                    for (j=0;j<L;j++) {
                        if (j<15 && i>15) {
                            buf[j+L*i]=0;
                        }
                    }
                }
                break;
            }
        }
    }

    for (j=0;j<L;j++) {
        for (i=0;i<L;i++) {
            for (k=0;k<FC;k++) {
                if (food[k].x==-1||food[k].y==-1) {
                    continue;
                }
                if (buf[i+j*L]!=1&&cx-16+i>=food[k].x && cx-16+i<food[k].x+5 && cy-16+j>=food[k].y && cy-16+j<food[k].y+5) {
                    buf[i+j*L]=2;
                }
            }
        }
    }
}

void drawfood(uint8_t *b, int x, int y) {
    int i, j;

    for (i=0;i<5;i++) {
        for (j=0;j<5;j++) {
            b[x+j+(y+i)*WIDTH]=2;
        }
    }
}

int main() {
    uint32_t ct[4];
    struct gif_file gf;
    uint8_t ico[WIDTH*HEIGHT];
    int k;
    int cur_food;
    int foodcnt;

    srand(time(0));

    ct[0]=0x000000;
    ct[1]=0xffff00;
    ct[2]=0xbccccc;
    memset(ico, 0, sizeof(ico));

    gf.wr_fnct=fwr;
    gf.wparm=fopen("pacman.gif", "wb");

    gif_init(&gf, WIDTH, HEIGHT, ct, 3, 0);
    gif_ext_loop(&gf, 0);
    cx=WIDTH>>1;
    cy=HEIGHT>>1;

    for (k=0;k<FC;k++) {
        int maxx=WIDTH-22;
        int maxy=HEIGHT-22;

        food[k].x=rand()%maxx+17;
        food[k].y=rand()%maxy+17;
        
        drawfood(ico, food[k].x, food[k].y);
    }

    gif_image(&gf, 0, 0, WIDTH, HEIGHT, NULL, 0, ico);

    while (1) {
        cur_food=-1;
        foodcnt=0;
        for (k=0;k<FC;k++) {
            if (food[k].x!=-1 && food[k].y!=-1) {
                foodcnt++;
            }            
        }
        
        for (k=0;k<FC;k++) {
            if (food[k].x!=-1 && food[k].y!=-1) {
                cur_food=k;
                break;
            }
        }
        if (cur_food==-1) {
            break;
        }

        for (k=0;k<FC;k++) {
            double cfl, kl;

            if (food[k].x==-1 || food[k].y==-1 || (k==cur_food&&foodcnt>1)) {
                continue;
            }

            cfl=sqrt((food[cur_food].x-cx)*(food[cur_food].x-cx) + (food[cur_food].y-cy)*(food[cur_food].y-cy));
            kl=sqrt((food[k].x-cx)*(food[k].x-cx) + (food[k].y-cy)*(food[k].y-cy));
            if (kl<cfl) {
                cur_food=k;
            }

        }
        while (abs(cx-food[cur_food].x)>2 || abs(cy-food[cur_food].y)>2) {
            if (abs(cx-food[cur_food].x)==1) {
                cx=food[cur_food].x;
            }
            if (abs(cy-food[cur_food].y)==1) {
                cy=food[cur_food].y;
            }
            if (cx<food[cur_food].x && cy<food[cur_food].y) {
                dir=3;
                cx+=2;
                cy+=2;
            } else if (cx<food[cur_food].x && cy==food[cur_food].y) {
                dir=2;
                cx+=2;
            } else if (cx==food[cur_food].x && cy>food[cur_food].y) {
                dir=0;
                cy-=2;
            } else if (cx<food[cur_food].x && cy>food[cur_food].y) {
                dir=1;
                cx+=2;
                cy-=2;
            } else if (cx>food[cur_food].x && cy>food[cur_food].y) {
                dir=7;
                cx-=2;
                cy-=2;
            } else if (cx>food[cur_food].x && cy==food[cur_food].y) {
                dir=6;
                cx-=2;
            } else if (cx>food[cur_food].x && cy<food[cur_food].y) {
                dir=5;
                cx-=2;
                cy+=2;
            } else if (cx==food[cur_food].x && cy<food[cur_food].y) {
                dir=4;
                cy+=2;
            }
            
            maul=(maul+1)&1;
            drawpac(ico);
            gif_graphicControlExtension(&gf, 8, -1);
            gif_image(&gf, cx-16, cy-16, 33, 33, NULL, 0, ico);
        }

        food[cur_food].x=-1;
        food[cur_food].y=-1;
    }


    gif_end(&gf);
    fclose(gf.wparm);

    return 0;
}